#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n,k;
    cin>>n>>k;
    long long niz[n];
    for(int i=0;i<n;i++)
    {
        cin>>niz[i];
    }
    long long a=0;
    if(k==1)
    {
        for(int i=0;i<n;i++)
        {
            a+=(n-i)*(1+i)*niz[i];
            a%=1000000007;
        }
    }
    if(k==0)
    {
        for(int i=0;i<n;i++)
        {
            a+=niz[i];
        }
    }
    cout<<a;
}